# VTools - 3D-Turtle
# Opensource
# Autoren R. Oldenburg, M. Rabel, J. Schuster, Uni Frankfurt 
# Kontakt oldenbur@math.uni-frankfurt.de

# Beispiel: Fraktaler Baum

# Idee von  http://bonelake.blogspot.com/2009/04/vpython-version-5.html
# Angepasst durch R. Oldenburg

from VTools import *
import random

def tree(t,trunkLength):
    if trunkLength < 5: return
    else:
        turnDz = random.randint(20,40)
        turnDx = random.randint(20,40)
        trunkShort = random.randint(10,20)
        t.setThickness(trunkLength/20.0)
        if trunkLength < 25: t.setColor(color.green)
        else: t.setColor((174/255.0,145/255.0,0))
        t.forward(trunkLength)
        # right trunk
        t.turn(turnDz,(0,0,1))
        tree(t,trunkLength-trunkShort)
        # left trunk
        t.turn(-2*turnDz,(0,0,1))
        tree(t,trunkLength-trunkShort)
        # front trunk
        t.turn(turnDz,(0,0,1))
        t.turn(turnDx,(1,0,0))
        tree(t,trunkLength-trunkShort)
        # back trunk
        t.turn(-2*turnDx,(1,0,0))
        tree(t,trunkLength-trunkShort)
        # restore
        t.turn(turnDx,(1,0,0))
        t.backward(trunkLength)


T=Turtle3D()
T.setAnimated(False)
T.turnUp(90)
tree(T,100)


